﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Vintagestory.API.Client;
using Vintagestory.API.Config;
using Vintagestory.API.Common;
using Vintagestory.API.Common.Entities;
using Vintagestory.API.MathTools;
using Vintagestory.API.Util;
using Vintagestory.GameContent;
using Vintagestory.API.Datastructures;

namespace jopainting
{
    public class BlockPainting : BlockContainer
    {
        //public override bool AllowHeldLiquidTransfer => true;

        //public AssetLocation bubbleSound = new AssetLocation("game", "effect/bubbling");

        public override ItemStack[] GetDrops(IWorldAccessor world, BlockPos pos, IPlayer byPlayer, float dropChanceMultiplier)
        {
            ItemStack[] droppedItemstack = base.GetDrops(world, pos, byPlayer, dropChanceMultiplier);
            if (droppedItemstack == null) return droppedItemstack;
            BlockEntityPainting bep = world.BlockAccessor.GetBlockEntity(pos) as BlockEntityPainting;
            foreach (ItemStack stack in droppedItemstack)
            {
                stack.Attributes.SetInt("width", bep.width);
                stack.Attributes.SetInt("height", bep.height);
                stack.Attributes.SetString("paintingR", bep.paintingR);
                stack.Attributes.SetString("paintingG", bep.paintingG);
                stack.Attributes.SetString("paintingB", bep.paintingB);
            }

            return droppedItemstack;
        }

        public override ItemStack OnPickBlock(IWorldAccessor world, BlockPos pos)
        {
            ItemStack pickedItemstack =  base.OnPickBlock(world, pos);
            if (pickedItemstack == null) return pickedItemstack;
            pickedItemstack = new ItemStack(world.GetBlock(pickedItemstack.Collectible.Code));
            BlockEntityPainting bep = world.BlockAccessor.GetBlockEntity(pos) as BlockEntityPainting;
            //return bep.fromStack;
            if (bep != null)
            {
                pickedItemstack.Attributes.SetInt("width", bep.width);
                pickedItemstack.Attributes.SetInt("height", bep.height);
                pickedItemstack.Attributes.SetString("paintingR", bep.paintingR);
                pickedItemstack.Attributes.SetString("paintingG", bep.paintingG);
                pickedItemstack.Attributes.SetString("paintingB", bep.paintingB);
            }
            return pickedItemstack;
        }

        /*public override void OnLoaded(ICoreAPI api)
        {
            base.OnLoaded(api);
        }*/

        /*public override bool OnBlockInteractStart(IWorldAccessor world, IPlayer byPlayer, BlockSelection blockSel)
        {
            be = world.BlockAccessor.GetBlockEntity(blockSel.Position) as BlockEntityPainting;
            setValues();

            if (base.OnBlockInteractStart(world, byPlayer, blockSel)) return true;

            if (be != null)
            {
                bool handled = be.OnInteract(world, byPlayer, blockSel);
                if (handled) return true;
            }

            return false;
        }*/


        /*
        public override string GetPlacedBlockInfo(IWorldAccessor world, BlockPos pos, IPlayer forPlayer)
        {
            return base.GetPlacedBlockInfo(world, pos, forPlayer);

            //be = world.BlockAccessor.GetBlockEntity(pos) as BlockEntityPainting;
            //setValues();
        }

        public override string GetPlacedBlockName(IWorldAccessor world, BlockPos pos)
        {
            return "Painting";
            return base.GetPlacedBlockName(world, pos);
        }*/
    }
}
